#!/usr/bin/env python

#Could make bounce effect when hit boundaries by sending in opposite direction for count down moment
#could make accelrate faster by using previuos x,y as well as start x,y as startx,y means you cant accelerate until back to starting point.

#               Added 'p' to pause feature
#03.05.04   Add backwash feature to make less likely to move back onto yourself
#               add delay to read accel as reads to fast once print taken out
#30.04.04   Put in absolute paths to stop desktop crashing
#27.04.04   Added 3 x high scores, highscore user name
#25.03.04   V2
#               Add 'bumper' round display size in map me make harder to crash into self
#25.03.10   Only map me once reach certain acceleration so don't crash back into self easily
#               Write current map to text file using 's' quit key
#               Collision detection
#24.03.10   Made initial mapping for snapy and food
#               Made random food appear in random place
#23.03.10:  Made snapy controled by accelerometer


import sys, pygame, time,  math,  os,  dbus,  random,  osso

from pygame.locals import *
import pygame.mixer

debug_line = ""
DEBUG_ON_DIE = 0
debug_xy = 0

#Consts
speed=.25          #Speed can be float and move will occur in integrs
speed_bumpx = .25
speed_bumpy = .25
smooth=30       #Rate of change in accelerometer before a speed/direction change is registered
accel_div=12
max_accel=25
map_accel = 1
accel_x=0
accel_y=0
accel_delay = 0
screen_x = 800
screen_y = 440
food_size = 20
toy_size = 20
snapy_size = 32
snapy_char = "."
blank_char = "*"
food_char="F"
toy_char = "T"
bumper_size = 8  #No of pixals around outside  of snapy where can't crash
immortal_period = 20

#Globals
ax = 0
ay = 0
az = 0
old_ax=0
old_ay=0
old_az=0
vibx, viby=0, 0
cx, cy, cz = 0, 0, 0
x, y, z =  screen_x / 2, screen_y /2, 200
old_x, old_y = 0, 0
right=0
left=0
up=0
down=0
food_x=0
food_y=0
toy_x = 0
toy_y = 0
food_score=0
food_no=0
time_score =0
death_detail = ""
death_history = ""
light_on = 0
score = 0
level_score = 0
high_score=0
high_score2 = 0
high_score3 = 0
high_score_name = ""
high_score2_name = ""
high_score3_name = ""
new_high_king = ""
current_high_king = ""
new_high_score = 0
death_yoink = 0
death_high = 0
immortal = immortal_period
mixer = pygame.mixer
toys = 0
snapy_length = 0
bg_bright = 0
red = 128
green = 128
blue = 255
redup = 1
greenup = 1
blueup = 0
backwash_char = 1
antibackwash_char = 2
max_backwash = 9
backwash_miny =[1]*(max_backwash+1)
backwash_maxy=[1]*(max_backwash+1)
paused = 0

line=blank_char*screen_x
print "Generating Map..."
map = [line]*screen_y
print "Map generated..."

def get_rotation():
    try:
        global ax
        global ay
        global az
        global old_ax
        global old_ay
        global old_az
        global right
        global left
        global up
        global down
        global cx, cy, cz
        global accel_div, max_accel, accel_x, accel_y,  accel_delay, speed
        global trip_switchx , trip_switchy , trip_value
        
        old_ax=ax
        old_ay=ay
        old_az=az
        
        #print " ** Getting accel co-ords**"
        f = open("/sys/class/i2c-adapter/i2c-3/3-001d/coord", 'r')
        coords = [int(w) for w in f.readline().split()]
        f.close()
        #print " ** Getting orientation**"
        #b = None
        #b = os.popen('run-standalone.sh dbus-send --system --type=signal /com/nokia/mce/signal com.nokia.mce.signal.sig_device_orientation_ind').read()
        
        ax = coords[0]
        ay = coords[1]
        az = coords[2]
        #print "x" + str(ax) + "y" + str(ay) + "z" + str(az)

        #Calculate if we are moving from calibrated y coordinate
        if ax > cx+smooth:
            left = 1
            right = 0
            #Do we want to accelerate as rotating so far?
            new_accel_x = int((ax-cx) / accel_div)
            #Prevent rapid change in accelearation rate to prevent crashing
        elif ax < cx-smooth:
            left = 0
            right = 1
            new_accel_x = int((cx-ax) / accel_div)
        else:
            new_accel_x = accel_x

            
        if new_accel_x > accel_x:
                accel_x = accel_x + speed
        elif new_accel_x < accel_x:
                accel_x = accel_x -speed                
        if accel_x > max_accel:
            accel_x = max_accel

            
        #Calculate if we are moving from calibrated y coordinate
        if ay < cy+smooth:
            up = 0
            down = 1
            new_accel_y = int((cy-ay) / (accel_div/2))
        elif ay > cy-smooth:
            up = 1
            down = 0
            new_accel_y = int((ay-cy) / (accel_div/2))
        else:
            new_accel_y = accel_y

            
        if new_accel_y > accel_y:
                accel_y = accel_y + speed                    
        elif new_accel_y < accel_y:
                accel_y = accel_y -speed
        if accel_y > max_accel:
            accel_y = max_accel

        coords = str(coords)
        jaccel = str(coords) 
        


        return (jaccel)
    except:
        return ('0,0,0,ERROR' + str(sys.exc_info()[:2]))

def vibes():
    bus = dbus.SessionBus()
    proxy = bus.get_object('org.freedesktop.Notifications', '/org/freedesktop/Notifications')    
    bb = 'run-standalone.sh dbus-send --print-reply --system --dest=com.nokia.mce /com/nokia/mce/request com.nokia.mce.request.req_vibrator_pattern_activate string:' + "\'PatternChatAndEmail\'"
    b = os.popen(bb)
    b.close()

def vibrate_small():
    #Vibrate
    bus = dbus.SessionBus()
    proxy = bus.get_object('org.freedesktop.Notifications', '/org/freedesktop/Notifications')
    bb = 'run-standalone.sh dbus-send --print-reply --system --dest=com.nokia.mce /com/nokia/mce/request com.nokia.mce.request.req_vibrator_pattern_activate string:' + "\'PatternTouchscreen\'"
    b = os.popen(bb)
    b.close()

def map_me(px,  py,  fill = ""):
    #Fill map where we have landed
    global map,  snapy_size,  snapy_char, accel_x,  accel_y, bumper_size,  immortal,  screen_y,  backwash_char,  antibackwash_char
    global max_backwash,  backwash_miny,  backwash_maxy
    
    if fill == "":
        fill = snapy_char
    
    #We use back wash characters first so you can't easily move back into yourself and keep dying 
    #really annoyingly by shaky hands from drinking all weekend
    replace_char = str(antibackwash_char)
    #Bit of optimising! - dont want to loop entire screen!
    loopy = min(backwash_miny)
    loopmax = max(backwash_maxy)
    while loopy <= loopmax:
        #tester = replace((map[loopy]),replace_char, fill )
        map[loopy] = map[loopy].replace(replace_char, fill )
        loopy = loopy + 1
    
    backwash_char = backwash_char + 1
    if backwash_char > max_backwash:
        backwash_char = 1
    antibackwash_char = antibackwash_char + 1
    if antibackwash_char > max_backwash:
        antibackwash_char = 1
    
    #This is the max range to check within
    backwash_miny[backwash_char] = py+bumper_size
    backwash_maxy[backwash_char] = py+snapy_size - (bumper_size * 2)
    
    count = py + bumper_size
    while (count <= py+snapy_size - (bumper_size * 2)):
        snapy_slice = str(backwash_char)*(snapy_size - (bumper_size * 2))
        map[count] = map[count][:px + bumper_size] + snapy_slice + map[count][px+snapy_size-bumper_size:]  #"................................" + map[count][px+32:]
        #Make sure the line does not become longer thant the screen!
        map[count] = map[count][:screen_x] 
        count = count + 1


def map_food(px, py):
    global map
    global food_size, food_char
    
    count = py + (food_size - 1)
    while (count > py-2):
        map[count] = map[count][:px] + (food_char*food_size)  + map[count][px+food_size+1:]
        #Make sure the line does not become longer thant the screen!
        map[count] = map[count][:screen_x] 
        count = count - 1

def map_toy(px, py):
    global map
    global toy_size, toy_char
    
    count = py + (toy_size - 1)
    while (count > py-2):
        map[count] = map[count][:px] + (toy_char*toy_size)  + map[count][px+toy_size+1:]
        #Make sure the line does not become longer thant the screen!
        map[count] = map[count][:screen_x] 
        count = count - 1


def  debug_me():
    try:
        global right,  up,  x,  y,  accel_x,  accel_y, speed, death_detail, death_history
        map_me(x, y, "#")
        print "writing map to disk..."
        file = open("/home/opt/map.txt" , 'w')
        count = 0
        while count <> screen_y -1:
            file.write(map[count] + "\n") 
            count = count + 1
        file.write("\n" + "\n")
        file.write("X:" + str(x) + " Y:" + str(y) + " Right:" + str(right) + " Up:" + str(up)  + " AccelX:" + str(accel_x) + " AccelY:" + str(accel_y) + " Speed:" + str(speed) + "\n") 
        file.write("Death Detail: " + death_detail + "\n")    
        file.write("History: " + death_history)
        file.close() 
    except:
        print "error writing debug file..."
        
def  write_file():
    try:
        global debug_line
        file = open("/home/opt/debug.txt" , 'w')
        file.write("Debug: " + debug_line)
        file.close() 
    except:
        print "error writing debug line file..."

def save_game_settings():
    try:
        global score,  high_score, high_score2 , high_score3 , high_score_name , high_score2_name , high_score3_name,  new_high_king
        global current_high_king,  new_high_score
        
        position = 0
        
        print "starting high score saving..."
        
        #Save top 3 high scores
        if score > high_score:
            position = 1
     
            high_score3_name = high_score2_name
            high_score3 = high_score2
            high_score2_name = high_score_name
            high_score2 = high_score
            high_score = score
            
            pet_name()
            high_score_name = new_high_king
            new_high_score = 1
            
        elif score > high_score2:
            high_score3_name = high_score2_name
            high_score3 = high_score2
            high_score2 = score
            
            position = 2
            pet_name()
            high_score2_name = new_high_king
            new_high_score = 1
            
        elif score > high_score3:
            high_score3 = score
            position = 3
            pet_name()
            high_score3_name = new_high_king
            new_high_score = 1
            
        if position <> 0:
            #Just saves high score
            print "writing game data to disk..."
            file = open("/home/opt/snapy.dat" , 'w')
            file.write("HighScore1: " + str(high_score) + "\n")
            file.write("HighScore2: " + str(high_score2) + "\n")
            file.write("HighScore3: " + str(high_score3) + "\n")
            file.write("HighKing1: " + high_score_name + "\n")
            file.write("HighKing2: " + high_score2_name + "\n")
            file.write("HighKing3: " + high_score3_name + "\n")
            
            file.close() 
        
            current_high_king = new_high_king
            
        print "high score saved! - Phew!"
    except:
        print "error saving score..."
        
def load_game_settings():
    global score,  high_score, high_score2 , high_score3 , high_score_name , high_score2_name , high_score3_name,  new_high_king
    
    #Just saves high score
    print "reading game data from disk..."
    try:
        file = open("/home/opt/snapy.dat" , 'r')  #open("/home/opt/snapy.dat" , 'r')
    except:
        save_game_settings()
        return
    try:
        buffer = file.readline()
        if buffer == "":
            high_score = 300
        else:
            high_score = int(buffer[len("HighScore1: "):])
        buffer = file.readline()
        if buffer == "":
            high_score2 = 200
        else:
            high_score2 = int(buffer[len("HighScore2: "):])
        buffer = file.readline()
        if buffer == "":
            high_score3 = 100
        else:
            high_score3 = int(buffer[len("HighScore3: "):])
        
        buffer = file.readline()
        if buffer == "":
            high_score_name = "Ssssss..."
        else:
            high_score_name = buffer[len("HighKing1: "):].strip()
        buffer = file.readline()
        if buffer == "":
            high_score2_name = "Shhh...."
        else:
            high_score2_name = buffer[len("HighKing2: "):].strip()
        buffer = file.readline()
        if buffer == "":
            high_score3_name = "Hisss..."
        else:
            high_score3_name = buffer[len("HighKing3: "):].strip()
        
      
        file.close() 
    except:
        print "error loading high score with file..."

 
def pet_name():
    global new_high_king, current_high_king,  red,  blue,  green,  redup,  blueup,  greenup
    
    #Clear screen
    black = 0, 0, 0
    cursor = "_"
    screen.fill(black)
    pygame.display.flip()
    
    sound = mixer.Sound("/home/opt/sfx/highscore.wav")
    #start playing
    channel = sound.play()
    
    pygame.font.init()
    current_string = current_high_king
    font = pygame.font.Font(None, 50)
    # Render the text
    text = font.render(' ENTER YOUR NAME OF FAME: ' + (current_string) , True, (80,80, 255), (0, 0, 0))
    # Create a rectangle
    textRect = text.get_rect()
    # Center the rectangle
    textRect.centerx = screen.get_rect().centerx
    textRect.centery = screen.get_rect().centery
    screen.blit(text, textRect)
    #display_box(screen, question + ": " + string.join(current_string,""))

    text = font.render(' (Press screen when finished!) '  , True, (255,80, 80), (0, 0, 0))
    # Create a rectangle
    textRect = text.get_rect()
    # Center the rectangle
    textRect.centerx = screen.get_rect().centerx
    textRect.top = screen.get_rect().centery + 50
    screen.blit(text, textRect)

    loop = 1
    while loop == 1:
        
        for event in pygame.event.get():
            #Screen Tapped
            if event.type == MOUSEBUTTONUP:
                loop = 0
            elif event.type == KEYDOWN and event.key == K_BACKSPACE:
                current_string = current_string[0:-1]
            elif event.type == KEYDOWN and event.key == K_RETURN:
                break
                loop = 0
            elif event.type == KEYDOWN and event.key == K_MINUS:
                current_string = current_string + ("_")
            elif event.type == KEYDOWN and event.key <= 127:
                current_string = current_string + (chr(event.key))
        
        
        #10 is long enough!
        if len(current_string) > 7:
            current_string = current_string[0:7]

        if redup == 1:
            red = red + 1
            if red >= 255:
                redup = 0
        else:
            red = red - 1
            if red <= 80:
                redup = 1
        
        if greenup == 1:
            green = green + 1
            if green >= 255:
                greenup = 0
        else:
            green = green - 1
            if green <= 80:
                greenup = 1
        
        if blueup == 1:
            blue = blue + 1
            if blue >= 255:
                blueup = 0
        else:
            blue = blue - 1
            if blue <= 80:
                blueup = 1
        
        if blue == 80 or blue == 255 or blue == 80 + ((256-80) / 2):
            if cursor == "_":
                cursor = "  "
            else:
                cursor = "_"
                
        text = font.render(' ENTER YOUR NAME OF FAME: ' + (current_string) + cursor , True, (red,green, blue), (0, 0, 0))
        # Create a rectangle
        textRect = text.get_rect()
        # Center the rectangle
        textRect.centerx = screen.get_rect().centerx
        textRect.centery = screen.get_rect().centery
        screen.blit(text, textRect)
        pygame.display.update()
    
    #Clear screen
    white = 255, 255, 255
    screen.fill(black)
    pygame.display.flip()
    new_high_king = (current_string)
    
def display_death_note():
    
    global score,  high_score, high_score2 , high_score3 , high_score_name , high_score2_name , high_score3_name,  new_high_king 
    global death_yoink,  death_high,  new_high_score,  red,  blue,  green,  redup,  blueup,  greenup
    
    print "death notes jim..."
    
    max_bright = 128
    glow_speed = 8
    
    if redup == 1:
        red = red + glow_speed
        if red >= max_bright:
            redup = 0
    else:
        red = red - glow_speed
        if red <= glow_speed:
            redup = 1
    
    if greenup == 1:
        green = green + glow_speed
        if green >= max_bright:
            greenup = 0
    else:
        green = green - glow_speed
        if green <= glow_speed:
            greenup = 1
    
    if blueup == 1:
        blue = blue + glow_speed
        if blue >= max_bright:
            blueup = 0
    else:
        blue = blue - glow_speed
        if blue <= glow_speed:
            blueup = 1

 
    
    black = (0, 0, 0)
    white = (255,255, 255)
    

    
    # Render the text
    if new_high_score == 0:
        txt_yoink = ' YOINK! '
        yoink_size = 300
        king_size = 50
        offset = 40
        king_back = white
        if death_yoink == 0:
            yoink_font = black
            yoink_back = white
            death_yoink = 1
        else:
            yoink_font = white
            yoink_back = black
            death_yoink = 0
        
    else:
        txt_yoink = 'IN THE GOOSETER!!'
        yoink_size = 120
        king_size = 80
        king_back = black
        offset = 0
        yoink_font = (red + 100, green+100, blue+100)
        yoink_back = black
        
    #This function displays note about your death /high score and waits for you to continue
    # Create a font
    font = pygame.font.Font(None, yoink_size)
    text = font.render(txt_yoink, True, yoink_font, yoink_back)
    
    font = pygame.font.Font(None, king_size)
    # Render the text
    text2 = font.render('1st King ' + high_score_name + ' : ' + str(high_score) , True, (red,0, 0),king_back)
    text3 = font.render('2nd Sir '+ high_score2_name + ' : ' + str(high_score2) , True, (0,green, 0), king_back)
    text4 = font.render('3rd Sad ' + high_score3_name + ' : ' + str(high_score3) , True, (0,0, blue), king_back)


    # Create a rectangle
    textRect = text.get_rect()
    # Center the rectangle
    textRect.centerx = screen.get_rect().centerx
    #textRect.centery = yoink_size / 2 
    textRect.top = 1
    # Blit the text
    screen.blit(text, textRect)
    
    # Create a rectangle
    textRect = text2.get_rect()
    # Center the rectangle
    textRect.centerx = screen.get_rect().centerx
    #textRect.centery = yoink_size #screen.get_rect().centery + (yoink_size / 2)
    textRect.top = yoink_size - offset
    # Blit the text
    screen.blit(text2, textRect)
    
    # Create a rectangle
    textRect = text3.get_rect()
    # Center the rectangle
    textRect.centerx = screen.get_rect().centerx
    #textRect.centery = yoink_size #screen.get_rect().centery + (yoink_size / 2)
    textRect.top = (yoink_size - offset) + (king_size)
    # Blit the text
    screen.blit(text3, textRect)

    # Create a rectangle
    textRect = text4.get_rect()
    # Center the rectangle
    textRect.centerx = screen.get_rect().centerx
    #textRect.centery = yoink_size #screen.get_rect().centery + (yoink_size / 2)
    textRect.top = (yoink_size - offset) + (king_size * 2)
    # Blit the text
    screen.blit(text4, textRect)
    
    
    pygame.display.update()
    
    print "death notes over onto the sport..."

def death_march():
    global  red,  blue,  green,  redup,  blueup,  greenup,  new_high_score
    
    #Reset these for the death note to update
    red = 128
    green = 64
    blue = 0
    redup = 0
    greenup = 1
    blueup = 1
    
    if new_high_score == 1:
        sound = mixer.Sound("/home/opt/sfx/gooseter.wav")
        #start playing
        channel = sound.play()
    
    print "Entering death march..."
    escape_death = 0
    while escape_death == 0:
        #Loops waiting for you to start/restart the game
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                sys.exit()
            elif event.type == KEYDOWN and event.key == K_ESCAPE:
                sys.exit()
            elif event.type == KEYDOWN and event.key == K_s:
                escape_death = 1
                #Screen Tapped
            elif event.type == MOUSEBUTTONUP:
                escape_death = 1
        display_death_note()
        
        if new_high_score == 1:
            if not channel.get_busy():
                sound = mixer.Sound("/home/opt/sfx/gooseter.wav")
                #start playing
                channel = sound.play()
                
        
    new_high_score = 0
    print "leave the death march.."

def eat_or_die():
    #See if snake is eating food
    #If so increment food counter, vibrate, reset new food
    
    global food_x, food_y, food_score, food_no, food_char, x, y, food_size, map,  left, right,  speed, accel_x,  accel_y, DEBUG_ON_DIE
    global bumper_size ,  death_detail, snapy_size,  snapy_char,  map_accel, immortal, immortal_period,  bg_channel
    global toy_char,  toy_size,  toy_x,  toy_y,  toys,  blank_snapy,  score,  high_score,  snapy_length,  time_score
    global high_score3,  level_score
    
    count = y + 31
    happy_meal = 0
    toy_time = 0
    funeral = 0
    food_slice = food_char*food_size
    
    #FOOD
    while ((count > y-2) ):
        if map[count][x:x+food_size] <> food_slice:
            if map[count][x:x+food_size].find(food_char) > -1:
                #We found food!
                happy_meal = 1
                break
            
        count = count -1
    
    #TOYS
    if toys == 1:
        print "Toys are in the pram..."
        count = y + 31
        toy_slice = toy_char*toy_size
        while ((count > y-2) ):
            if map[count][x:x+toy_size] <> toy_slice:
                if map[count][x:x+toy_size].find(toy_char) > -1:
                    #We found a toy!
                    print "found a toy!"
                    toy_time = 1
                    break
            
            count = count -1
    if toy_time == 1:
        #Toy resets speed to slowest
        speed = .25
        toys = 0
        vibrate_small()
        #sfx_rnd = random.randint(1, 5)
        sfx_file = "/home/opt/sfx/toy.wav"
        print sfx_file
        sound = mixer.Sound(sfx_file)
        #start playing
        channel = sound.play()
        #clear 
        screen.blit(blank_snapy, (toy_x,toy_y))
        #score 5 X food points!
        food_score = food_score + (food_no * 5)

    
    
    if happy_meal == 0 and toy_time ==0:
        ################
        #Check for the grim reaper
        ################
        
        snapy_slice = snapy_char*(snapy_size - (bumper_size*2))
        if right == 1 and up == 1:
            #Right and up
            y_offset = 0
            x_offset = snapy_size - bumper_size
        elif right == 1 and up == 0:
            #right and down
            y_offset = snapy_size - bumper_size
            x_offset = snapy_size - bumper_size
        elif right == 0 and up == 1:
            #left and up
            y_offset = 0
            x_offset = 0
        else:
            #left and down
            y_offset = snapy_size - bumper_size
            x_offset = 0
        
        if map[y+y_offset][x+bumper_size:x+snapy_size-(bumper_size * 2)] <> snapy_slice:
            if map[y+y_offset][x+bumper_size:x+snapy_size-(bumper_size * 2)].find(".") > -1:
                #Top/Bottom Crash
                funeral = 1
                death_detail = "Hit on main line@ X:" + str(x+x_offset) + " Y:" + str(y+y_offset) + " Count:" + str(count) + " Right: " + str(right) + " Up:" + str(up)+ map[y+y_offset][x+bumper_size:x+snapy_size-(bumper_size * 2)]
            else:
                count = int(speed) + int(accel_y)
                while count > 0:
                    if map[(y+y_offset) - count][x+x_offset] == ".":
                        funeral = 1
                        death_detail = "Paper cut @ X:" + str(x+x_offset) + " Y:" + str(y+y_offset) + " Count:" + str(count) + " Right: " + str(right) + " Up:" + str(up) + map[y+y_offset][x+bumper_size:x+snapy_size-(bumper_size * 2)]
                        break
                    count = count -1
                    
                    
    #funeral = 0
    if happy_meal == 1 or funeral == 1:
        if DEBUG_ON_DIE == 1 and funeral ==1:
            debug_me()
            vibes()
            sys.exit()
            
        if funeral == 1:
            print "death by canabalism"
            food_score = 0
            time_score = 0
            snapy_length = 0
            level_score = 0
            food_no = 0
            speed = .25
            #Clear screen
            white = 255, 255, 255
            screen.fill(white)
            pygame.display.flip()
            vibes()
            #load the sound    
            sound = mixer.Sound("/home/opt/sfx/hit.wav")
            #start playing
            channel = sound.play()
            #Save high score
            if score >= high_score3:
                save_game_settings()
            bg_bright = 255
            
            #DEATH LOOP until restart
            #display_death_note()
            death_march()
            
        elif happy_meal == 1:
            #Increase food_score
            print "num num num...."
            vibrate_small()
            #Play eat sfx
            #load the sound 
            sfx_rnd = random.randint(1, 5)
            sfx_file = "/home/opt/sfx/hiss"+ str(sfx_rnd) + ".wav"
            print sfx_file
            sound = mixer.Sound(sfx_file)
            #start playing
            channel = sound.play()
            #New b/g sfx
            if not bg_channel.get_busy():
                if sfx_rnd == 1:
                    sfx_rnd = random.randint(1, 3)
                    sfx_file = "/home/opt/sfx/jungle"+ str(sfx_rnd) + ".wav"
                    print sfx_file
                    sound = mixer.Sound(sfx_file)
                    #start playing
                    bg_channel = sound.play()
        
            #We look at acceleration cos if your going too slow you don't score. STUNG!
            speed_score = (int(accel_x) - map_accel)
            if speed_score < 0:
                speed_score = 0
            speed_score2 = int(accel_y) - map_accel
            if speed_score2 < 0:
                speed_score2 = 0
            speed_score = (speed_score + speed_score2) 
            #The more food you have eaten the higher the score.
            #toy_time will double your score!
            food_score = food_score + (food_no * speed_score) 
            food_score = food_score + (food_no * snapy_length) 
            #Kind of a level counter really
            food_no = food_no +1
            #Store the score for this level here then clear old values again
            level_score = level_score + food_score
            food_score = 0

            #Speed in increases 1 per level
            speed = speed + .25
            


            
        #Reset Snapy
        x, y, z = screen_x / 2, screen_y /2, 200
        snapy_length = 0
        
        #Clear screen
        screen.fill(black)
        
        #New food
        food_x = random.randint(0, screen_x-32)
        food_y = random.randint(0, screen_y-32)
        rnd_no = random.randint(1, 4)
        food = pygame.image.load("/home/opt/images/food" + str(rnd_no) + ".jpg").convert()
        screen.blit(food, (food_x,food_y))
        if speed > 3:
            if rnd_no < 2:
                #Create a toy
                toys = 1
                toy_x = random.randint(0, screen_x-32)
                toy_y = random.randint(0, screen_y-32)
                toy = pygame.image.load("/home/opt/images/toy.jpg").convert()
                screen.blit(toy, (toy_x,toy_y))
                sfx_file = "/home/opt/sfx/rattle.wav"
                print sfx_file
                sound = mixer.Sound(sfx_file)
                #start playing
                bg_channel = sound.play()
        
        
        print "Generating Map..."
        map = [line]*screen_y
        print "Map generated..."
        map_food(food_x, food_y)
        if toys == 1:
            map_toy(toy_x, toy_y)
        map_me(x, y)
        immortal = immortal_period
        
    
debug_line = "open"
write_file()
#Load high score etc
load_game_settings()
debug_line = "start py game"
write_file()
#Start game running.....
pygame.mixer.init()                                             
pygame.init()
#Defaults
size = width, height = screen_x, screen_y
black = 0, 0, 0
debug_line = "Get rotation"
write_file()
#Rotation Defaults
str_ac = get_rotation()
#Calibrate x,y
cx = ax
cy = ay
#Setup screen
screen = pygame.display.set_mode(size)
screen.fill(black)
pygame.mouse.set_visible(0)


snapy = pygame.image.load("/home/opt/images/head.jpg").convert()
snapy.set_colorkey(black, RLEACCEL)
immortal_snapy = pygame.image.load("/home/opt/images/immortal_head.jpg").convert()
immortal_snapy.set_colorkey(black, RLEACCEL)
blank_snapy = pygame.image.load("/home/opt/images/blank_head.jpg").convert()

food = pygame.image.load("/home/opt/images/food" + str(random.randint(1, 4)) + ".jpg").convert()
food_x = random.randint(0, screen_x-32)
food_y = random.randint(0, screen_y-32)
screen.blit(food, (food_x,food_y))
map_food(food_x, food_y)


#We get rotaion again so we know the direction we are travelling before we start collision detection
str_ac = get_rotation()

#uncomment to run in FullScreen Mode
#pygame.display.toggle_fullscreen()
pygame.display.flip()

#Initial background sfx
sound = mixer.Sound("/home/opt/sfx/jungle.wav")
#start playing
bg_channel = sound.play()
# Initialise clock
clock = pygame.time.Clock()



# Wait for input.
while 1:

    # Make sure game doesn't run at more than 60 frames per second
    clock.tick(60)

    #Turn on backlight
    if light_on <= 0:
        osso_c = osso.Context("osso_test_device_on", "0.0.1", False)
        device = osso.DeviceState(osso_c) 
        device.display_state_on()
        light_on = 100
    else:
        light_on = light_on - 1
    
    if paused == 0:
        old_x = x
        old_y = y
        
        #Accel. movement
        str_ac = get_rotation()
        if right == 1:
            x = x + (int(speed) + int(accel_x))
        else:
            x = x - (int(speed) + int(accel_x))
        
        #V2: Make 'bouce' effect    
        if x < 0:
            x = 0
            if vibx == 0:
                vibrate_small()
                vibx = 1
        elif x > 800-32:
            x = 800-32
            if vibx == 0:
                vibrate_small()
                vibx = 1
        else:
            vibx = 0
        
        
        if up ==1:
            y = y - (int(speed) + int(accel_y))
        else:
            y = y + (int(speed) + int(accel_y))
        
        if y < 0:
            y = 0
            if viby == 0:
                vibrate_small()
                viby = 1
        elif y > screen_y-snapy_size:
            y = screen_y-snapy_size
            if viby == 0:
                vibrate_small()
                viby = 1
        else:
            viby = 0
        
        snapy_length = snapy_length + 2
        #Time keeps counting up until death do us part...
        time_score = time_score + 1
        
        if debug_xy == 1:
            death_history = death_history + str(x) + ":" + str(y) + "@" + str(accel_x) + ":" + str(accel_y) + "\n"
            
        #See if we are eating!
        eat_or_die()    


        #Draw me
        if immortal > 0:
            screen.blit(immortal_snapy, (x, y))
            immortal = immortal - 1
        else:
            screen.blit(snapy, (x,y))
            #Place me on map
            map_me(x, y)

        if debug_xy == 1:
            pygame.display.set_caption ("x:" + str(x) + " y:" + str(y) + " ax:" + str(accel_x) + " ay:" + str(accel_y)) 
        else:
            score = time_score + level_score
            dis_hi = high_score
            if score > high_score:
                dis_hi = score
            pygame.display.set_caption ("Snapy!! S:" + str(score) + " H:" + str(dis_hi) + " L:" + str(food_no)  + " Sp:" + str(speed))


        #button1rect = button1.get_rect()
        #print "accel: " + str_ac  + str(accel_x)
        pygame.display.flip()
        
    else:
        pygame.display.set_caption ("PAUSED! - hit p to continue...." + "Snapy!! Score:" + str(score) ) 
    
    q = 0
    w = 0
    for event in pygame.event.get():
        print "accel: " + str(az) + ":" + str(ay) + ""
        if event.type == pygame.QUIT:
            sys.exit()
        elif event.type == KEYDOWN and event.key == K_ESCAPE:
            sys.exit()
        elif event.type == KEYDOWN and event.key == K_s:
            #Write the map data to a file so we can debug
            debug_me()
            sys.exit()
        elif event.type == KEYDOWN and event.key == K_p:
            #Write the map data to a file so we can debug
            if paused == 0:
                paused = 1
            else:
                paused = 0
                
        elif x != q or y != w:
             q = x
             w = y



